ECHO OFF
CLS
ECHO This batch file attempts to optimize drive C.
ECHO 
ECHO The following command performs directory optimization for
ECHO drive C:
ECHO 
ECHO 

OPTdir C: /OD

ECHO 
ECHO 
ECHO Now, we need to test the errorlevel returned.  These codes
ECHO must be tested from highest to lowest, or this batch file
ECHO may not work properly.
ECHO 
ECHO 

IF ERRORLEVEL 27 GOTO USER_ABORT
IF ERRORLEVEL 26 GOTO BAD_COMMAND
IF ERRORLEVEL 10 GOTO DISK_CACHE
IF ERRORLEVEL 8 GOTO CHECK_DISK
IF ERRORLEVEL 7 GOTO NO_MEMORY
IF ERRORLEVEL 6 GOTO FATAL_ERR
IF ERRORLEVEL 4 GOTO NO_MEMORY
IF ERRORLEVEL 3 GOTO VERIFY_DISK
IF ERRORLEVEL 2 GOTO NO_DRIVE
IF ERRORLEVEL 1 GOTO BAD_FAT

ECHO 
ECHO No problems running OPTdir!
GOTO BATCH_END

:BAD_COMMAND
ECHO 
ECHO OPTdir did not understand the command it was given.
ECHO Please edit this batch file to correct the command
ECHO before using it again.
GOTO BATCH_PAUSE

:BAD_FAT
ECHO 
ECHO Either the FAT or the directories are bad.  Please run
ECHO CHKDSK to try to fix them.
ECHO 
GOTO BATCH_PAUSE

:NO_DRIVE
ECHO 
ECHO The drive you specified was not available.  Please
ECHO either modify this batch file to use the correct drive,
ECHO or make sure that the drive is available before using
ECHO OPTdir.
GOTO BATCH_PAUSE

:VERIFY_DISK
ECHO 
ECHO OPTdir will attempt to fix your disk problems. Press
ECHO any key to run OPTdir's Verify/Fix-Disk command.
ECHO 
PAUSE
OPTdir C: /V
IF ERRORLEVEL 27 GOTO USER_ABORT
IF ERRORLEVEL 1 GOTO CANNOT_FIX
GOTO RUN_CHECK

:NO_MEMORY
ECHO 
ECHO OPTdir needs either more RAM or more disk space available
ECHO before it can operate on your system.
GOTO BATCH_PAUSE

:FATAL_ERR
ECHO 
ECHO OPTdir encountered a fatal error.  You must manually use
ECHO the Check-Disk command and/or the Verify/Fix-Disk command
ECHO before OPTdir will operate from the batch file.
ECHO 
GOTO BATCH_PAUSE

:CHECK_DISK
ECHO 
ECHO Press any key to run Check-Disk to fix errors on drive C.
ECHO 
PAUSE

:RUN_CHECK
ECHO 
OPTDIR /C C:
GOTO BATCH PAUSE

:DISK_CACHE
ECHO 
ECHO OPTdir sensed a dangerous type of disk caching with which
ECHO it cannot successfully operate.  Please turn disk caching
ECHO off before running OPTdir, or run OPTdir before your disk
ECHO caching is activated
ECHO 
GOTO BATCH_PAUSE

:USER_ABORT
ECHO 
ECHO The user pressed the ESC key to terminate early!
ECHO 
GOTO :BATCH_PAUSE

:CANNOT_FIX
ECHO 
ECHO Sorry!  OPTdir could not completely fix the errors.
ECHO 

:BATCH_PAUSE
PAUSE
:BATCH_END
